$(document).ready(function() {
	// sidebar's header
	$("#SecondaryNav h3").css({"width": $(".SiteBox h3").width() });
	$(".SiteBox:first").css({"padding-top": $("#SecondaryNav h3").outerHeight() });

	// select the current page in the sidebar at page loading (for both sites)
	var curPage = $(location).attr("href").split('/').pop();
	if (curPage.indexOf('#') >= 0) {
		var anchor = curPage.split('#').pop();
	} else {
		var anchor = curPage;
		$("h1:first").removeClass("anchor");
	}
	$(".SiteBox").find('a[href$="' + anchor + '"]').addClass("active");
	
	// keep the current anchor selected (for the single file site)
	$(".SiteBox a").bind('click', function(e){
		$("h1:first").addClass("anchor"); // restore the first h1's anchor class once we started using anchors
		$(".SiteBox a").removeClass("active");
		$(this).closest("a").addClass("active");
	});
	
	$('#SecondaryNav').on('mousewheel DOMMouseScroll', function(e) {
		if (this.scrollHeight <= this.offsetHeight)
			return;

		e = e.originalEvent;
		var delta = (e.wheelDelta) ? -e.wheelDelta : e.detail;
		var isIE = Math.abs(delta) >= 120;
		var scrollPending = isIE ? delta / 2 : 0;
		if (delta < 0 && (this.scrollTop + scrollPending) <= 0) {
			this.scrollTop = 0;
			e.stopPropagation();
			e.preventDefault();
		} else if (delta > 0 && (this.scrollTop + scrollPending >= (this.scrollHeight - this.offsetHeight))) {
			this.scrollTop = this.scrollHeight - this.offsetHeight;
			e.stopPropagation();
			e.preventDefault();
		}
	});

	// select the current anchor in the sidebar depending on scroll position (single file site)
	var lastId
	,	sideMenu = $(".SiteBox")
	,	menuItems = sideMenu.find('a[href*="#"]')
	,	scrollItems = menuItems.map(function() {
			var item = $($(this).attr("href"));
			if (item.length) {
				return item;
			};
		})
	,	scrollIntoView = function(element) {
			var container = $("#SecondaryNav")
			,	cBounds = container.get(0).getBoundingClientRect()
			,	eBounds = element.get(0).getBoundingClientRect()
			,	eBot = element.get(0).offsetTop + element.height();
			if(! (eBounds.top > cBounds.top && eBounds.bottom < cBounds.bottom)) {
				container.stop(true,false).animate({scrollTop: eBot - (container.height() / 2)}, 800);
			}
		};

	$(window).scroll(function() {
		var fromTop = $(this).scrollTop() + 100
		,	cur = scrollItems.map(function() {
				if ($(this).offset().top < fromTop) {
					return this;
				}
			});
		if (scrollItems.length > 0) { 
			// we're on the single page site
			cur = cur[cur.length - 1];
			var id = cur && cur.length ? cur.attr("id") : "";
			if (lastId !== id) {
				$(".SiteBox a").removeClass("active");
				var e = $(".SiteBox").find('a[href="#' + id + '"]');
				e.addClass("active");
				scrollIntoView(e);
				lastId = id;
			}
		}
	});
});
